package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.CotacaoDAO;
import com.rjconsultores.ventaboletos.entidad.Cotacao;
import com.rjconsultores.ventaboletos.entidad.Moneda;

@Repository("cotacaoHibernateDAO")
@SuppressWarnings("unchecked")
public class CotacaoHibernateDAO extends GenericHibernateDAO<Cotacao, Integer>
		implements CotacaoDAO {

	@Autowired
	public CotacaoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<Cotacao> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	public List<Cotacao> buscar(String descmoneda) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public void inativarCotacoesAntigas(Moneda moneda) {

		StringBuilder sql = new StringBuilder("UPDATE COTACAO SET ACTIVO = 0 WHERE MONEDA_ID = ");
		sql.append(moneda.getMonedaId());

		getSession().createSQLQuery(sql.toString()).executeUpdate();

	}

}
